local AYB = AllYourBase

AYB.ReportPage = {}
AYB.NextPage = {}
AYB.Constants = {}
AYB.Options = {}
AYB.Constants.CurrentVersion = "0.5.2"
AYB.Constants.hasLoggedIn = false
AYB.Constants.debugLast = "Nothing"
AYB.Constants.isCrafterOpen = false
AYB.Constants.lastCrafterOpen = 0
AYB.Constants.shouldSyncShipments = false
AYB.Constants.CurrentModelAnimation = 60
local source = AYB.Constants.debugLast

AllYourBaseVars = {
	["Settings"] = {},
	["Data"] = {},
	["CurrentVersion"] = -1
	}

local me, shortMe, race, faction

AYB.CompletedQueue = {}

AYB.Main = CreateFrame("Frame","AllYourBaseMain")
AYB.Main.Timer = 0

AYB.ShipmentUpdater = CreateFrame("Frame", "AllYourBaseShipmentUpdater")
AYB.WhichCrafter = CreateFrame("Frame", "AllYourBaseDetermineCrafter")
-- AYB.ReportModelTimer = CreateFrame("Frame", "AllYourBaseReportModelTimer")
-- AYB.ReportModelTimer.Timer = 0
-- AYB.ModelAlphaTimer = CreateFrame("Frame", "AllYourBaseModelAlphaTimer")
-- AYB.ModelAlphaTimer:Hide()
-- AYB.ModelAlphaTimer.Timer = 0

for k, v in pairs({
	"PLAYER_ENTERING_WORLD",
	"SHOW_LOOT_TOAST",
	"ADDON_LOADED",
	"PLAYER_LOGIN",
	"UNIT_INVENTORY_CHANGED",
	"SHIPMENT_CRAFTER_CLOSED",
	"SHIPMENT_CRAFTER_OPENED",
	"SHIPMENT_CRAFTER_REAGENT_UPDATE",
	"SHIPMENT_UPDATE",
	"GARRISON_ARCHITECT_CLOSED",
	"GARRISON_ARCHITECT_OPENED",
	"GARRISON_BUILDINGS_SWAPPED",
	"GARRISON_BUILDING_ACTIVATABLE",
	"GARRISON_BUILDING_ACTIVATED",
	"GARRISON_BUILDING_ERROR",
	"GARRISON_BUILDING_LIST_UPDATE",
	"GARRISON_BUILDING_PLACED",
	"GARRISON_BUILDING_REMOVED",
	"GARRISON_BUILDING_UPDATE",
	"GARRISON_FOLLOWER_ADDED",
	"GARRISON_FOLLOWER_LIST_UPDATE",
	"GARRISON_FOLLOWER_REMOVED",
	"GARRISON_FOLLOWER_XP_CHANGED",
	"GARRISON_HIDE_LANDING_PAGE",
	"GARRISON_INVASION_AVAILABLE",
	"GARRISON_INVASION_UNAVAILABLE",
	"GARRISON_LANDINGPAGE_SHIPMENTS",
	"GARRISON_MISSION_BONUS_ROLL_COMPLETE",
	"GARRISON_MISSION_BONUS_ROLL_LOOT",
	"GARRISON_MISSION_COMPLETE_RESPONSE",
	"GARRISON_MISSION_FINISHED",
	"GARRISON_MISSION_LIST_UPDATE",
	"GARRISON_MISSION_NPC_CLOSED",
	"GARRISON_MISSION_NPC_OPENED",
	"GARRISON_MISSION_STARTED",
	"GARRISON_MONUMENT_CLOSE_UI",	
	"GARRISON_MONUMENT_LIST_LOADED",
	"GARRISON_MONUMENT_REPLACED",
	"GARRISON_MONUMENT_SELECTED_TROPHY_ID_LOADED",
	"GARRISON_MONUMENT_SHOW_UI",
	"GARRISON_RECALL_PORTAL_LAST_USED_TIME",
	"GARRISON_RECALL_PORTAL_USED",
	"GARRISON_RECRUITMENT_FOLLOWERS_GENERATED",
	"GARRISON_RECRUITMENT_NPC_CLOSED",
	"GARRISON_RECRUITMENT_NPC_OPENED",
	"GARRISON_RECRUITMENT_READY",
	"GARRISON_RECRUIT_FOLLOWER_RESULT",
	"GARRISON_SHOW_LANDING_PAGE",
	"GARRISON_TRADESKILL_NPC_CLOSED",
	"GARRISON_UPDATE",
	"GARRISON_UPGRADEABLE_RESULT",
	"GARRISON_USE_PARTY_GARRISON_CHANGED",
	"SHIPMENT_UPDATE"}) do AYB.Main:RegisterEvent(v) end

AYB.WhichCrafter:RegisterEvent("SHIPMENT_CRAFTER_INFO")
	
function AYB.Main.OnEvent(self, event, ...)
	if ( event == "UNIT_INVENTORY_CHANGED" and ... == "player" ) then
		AYB.CaptureInventoryIDs()
	elseif event == "SHOW_LOOT_TOAST" then
		local arg1, arg2, arg3 = ...
		if arg1 == "currency" and arg2:find("Garrison Resources") then
			if AllYourBaseVars.Settings.debugMode then AYB.Print("Resetting your Resources Counter!") end
			AllYourBaseVars.Data[me].cacheTimer = time() + (AllYourBaseVars.Settings.resourceWatchLimit / 6 * 3600)
			AllYourBaseVars.Data[me].lastRetrievedCache = time()
			AllYourBaseVars.Data[me].broadcastCache = false
			-- math explanation: resources accumulate 1 every 10 minutes, or 6 per hour. Divide by 6 to get the hours before the limit is up, then multiply by 3600 for seconds
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		if not AllYourBaseStatusButton then
			AYB.StatusButton = CreateFrame("Button", "AllYourBaseStatusButton", GarrisonLandingPage, "AllYourBaseReportButtonTemplate")
			local statusButton = AYB.StatusButton
			statusButton:SetPoint("TOPLEFT", 230, -52)
			statusButton:Show()
			statusButton:SetScript("OnClick", function(self) HideParentPanel(self) AYB.DisplayAllReports("slash") end)
			local text = statusButton:CreateFontString(nil, "Border", "ChatFontSmall")
			text:SetText("All Your Base\nStatus Report")
			text:SetPoint("TOPLEFT", 35, -2)
			text:Show()
		end
		AYB.CaptureInventoryIDs()
	elseif event == "GARRISON_MISSION_STARTED" then
		AYB.StartMission(...)
	elseif event == "GARRISON_BUILDING_PLACED" then
		AYB.StartBuilding(false, ...)
	elseif event == "GARRISON_BUILDING_REMOVED" then
		AYB.StartBuilding(true, ...)
	elseif event == "GARRISON_MISSION_COMPLETE_RESPONSE" then
		AYB.RemoveCompletedMission(...)
	elseif event == "GARRISON_BUILDING_ACTIVATED" then
		AYB.RemoveCompletedBuilding(...)
	elseif event == "ADDON_LOADED" then
		if ... == "AllYourBase" then
			me = UnitName("player").."-"..GetRealmName()
			shortMe = me:match("([^-]+)")
			race = select(2, UnitRace("player"))
			faction = UnitFactionGroup("player")
			if (not AllYourBaseVars) or (AllYourBaseVars.CurrentVersion ~= AYB.Constants.CurrentVersion) then
				AYB.InitializeVariablesAndSettings()
			end
			if not AllYourBaseVars.Data[me] then
				AllYourBaseVars.Data[me] = {
					["Buildings"] = {},
					["Shipments"] = {},
					["Missions"] = {},
					["Followers"] = {},
					["Race"] = race,
					["RaceID"] = AllYourBase.RaceIDs[race],
					["Gender"] = UnitSex("player") - 2,
					["Inventory"] = {},
					["cacheTimer"] = 9999999999999999999999,
					["lastRetrievedCache"] = 9999999999999999999999,
				}
			end
			AYB.SetOptionsChecks()
		end
	elseif event == "PLAYER_LOGIN" then
		LoadAddOn("Blizzard_GarrisonUI")
		AYB.CaptureInventoryIDs()
		if not AYB.Constants.hasLoggedIn then -- only force show the frame once, at log-in, to trigger the message.
			AYB.Main:Show()
		end
		AYB.ShipmentUpdater:Hide()
		-- AYB.ReportModelTimer:Hide()
		AYB.ShipmentUpdater.Timer = 0
		AYB.CleanUpUnusedEntries("Missions")
		AYB.CleanUpUnusedEntries("Buildings")
	elseif event == "GARRISON_MISSION_NPC_OPENED" or event == "GARRISON_ARCHITECT_OPENED" then -- when in the mission UI, suspend syncing, otherwise the information can get re-added between completing a mission and opening the loot chest
		AYB.Main:Hide()
	elseif event == "GARRISON_MISSION_NPC_CLOSED" or event == "GARRISON_ARCHITECT_CLOSED" then -- resume sync when the UI is closed
		AYB.Main:Show()
	elseif event == "SHIPMENT_UPDATE" and ... then
	--	AYB.Print(event)
	--	AYB.ShipmentUpdater.Timer = 0
	--	AYB.ShipmentUpdater:Show()
		if AYB.Constants.isCrafterOpen then
			AYB.Constants.shouldSyncShipments = true
		end
	elseif event == "SHIPMENT_CRAFTER_OPENED" then
		-- print(event)
		AYB.WhichCrafter:Show()
		AYB.Constants.isCrafterOpen = true
		-- AYB.Print("It's open.")
	elseif event == "SHIPMENT_CRAFTER_CLOSED" then
		-- print(event)
		-- AYB.TrueUpShipmentQueue(AYB.Constants.lastCrafterOpen)
		AYB.WhichCrafter:Hide()		
		AYB.Constants.isCrafterOpen = false
		-- AYB.Print("It's not open.")
		if AYB.Constants.shouldSyncShipments then
			AYB.Constants.shouldSyncShipments = false
			C_Garrison.RequestLandingPageShipmentInfo()
			GarrisonLandingPageReport_GetShipments(GarrisonLandingPageReport)
			AYB.ShipmentUpdater.Timer = 0
			AYB.ShipmentUpdater:Show()
		end
	elseif event == "GARRISON_SHOW_LANDING_PAGE" then

		
	--[[
	elseif event ~= "SHIPMENT_UPDATE" then
		print(event, ...)		
	--]]
	end
end

--[[
function AYB.WhichCrafter.OnEvent(self, event, ...)
	if event == "SHIPMENT_CRAFTER_INFO" then
		AYB.ParseCrafter(...)
	end
end
]]

function AYB.ParseCrafter(self, event, success, queued, total, plotID)
	-- AYB.Print("parsing")
	local buildingID
	for k, v in ipairs(C_Garrison.GetBuildings()) do
		if v.plotID == plotID then
			buildingID = v.buildingID
			break
		end
	end
	AYB.Constants.lastCrafterOpen = buildingID
	-- AYB.Print("Parser makes lastCrafter ".. AYB.BuildingIDsToNames[buildingID][faction])
	-- AYB.TrueUpShipmentQueue(buildingID)
end

function AYB.Main.OnUpdate(self, timer)
	AYB.Main.Timer = AYB.Main.Timer + timer
	if AYB.Main.Timer >= 5 then
		AYB.Main.Timer = 0
		AYB.Sync()
	end
end

function AYB.ShipmentUpdater.OnUpdate(self, elapsed)
	AYB.ShipmentUpdater.Timer = AYB.ShipmentUpdater.Timer + elapsed
	if AYB.ShipmentUpdater.Timer >= 2 then
		AYB.StartShipment(AYB.Constants.lastCrafterOpen)
		AYB.ShipmentUpdater.Timer = 0
		AYB.ShipmentUpdater:Hide()
	end
end

function AYB.StartMission(...)
	local started = ...
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.missionID == started then
			AllYourBaseVars.Data[me].Missions[started] = v
			AllYourBaseVars.Data[me].Missions[started].startTime = time()
			AllYourBaseVars.Data[me].Missions[started].endTime = time() + AYB.TextToSecs(v.timeLeft)
			AllYourBaseVars.Data[me].Missions[started].doBroadcast = true
		end
	end
end

function AYB.StartBuilding(hasRemoved, ...)
	local arg1, arg2 = ...
	local oldBuilding
	if hasRemoved then
		oldBuilding = AllYourBase.BuildingIDsToNames[arg2][faction]
	end
	if oldBuilding and AllYourBaseVars.Data[me].Buildings[oldBuilding] then
		AllYourBaseVars.Data[me].Buildings[oldBuilding] = nil
	end		
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.isBuilding then
			if not AllYourBaseVars.Data[me].Buildings[v.name] then
				AllYourBaseVars.Data[me].Buildings[v.name] = v
				AllYourBaseVars.Data[me].Buildings[v.name].startTime = time()
				AllYourBaseVars.Data[me].Buildings[v.name].doBroadcast = true
				AllYourBaseVars.Data[me].Buildings[v.name].endTime = time() + AYB.TextToSecs(v.timeLeft)
			end
		end
	end
end

function AYB.StartShipment(crafter)
	--local buildings, shipments = C_Garrison.GetBuildings(), {}
	local s = {C_Garrison.GetLandingPageShipmentInfo(crafter)}
	local building = AllYourBase.BuildingIDsToNames[crafter][faction]
	--[[
	for i = 1, #buildings do
		local buildingID = buildings[i].buildingID
		if buildingID then
			-- local name, texture, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, timeleftString, itemName, itemIcon, itemQuality, itemID = C_Garrison.GetLandingPageShipmentInfo(buildingID);
			shipments[buildingID] = {C_Garrison.GetLandingPageShipmentInfo(buildingID)}
		end
	end
	local t, n = 0, 0
	for k, v in pairs(shipments) do
		if v[5] then
			t = t + v[5]
			n = n + 1
		end
	end
	]]
	-- AYB.Print("starting shipment from "..building)
	-- AYB.Print(format("Queue status: %d ready of %d total, so %d pending. Next ready in %s, all done in %s.", s[4], s[5], s[5] - s[4], s[8], AYB.SecsToText((s[5] - s[4] - 1) * 3600 * 4 + AYB.TextToSecs(s[8]))))
	if s[4] and s[5] and s[8] then
		AllYourBaseVars.Data[me].Shipments[building] = {
			["endTime"] = time() + (s[5] - s[4] - 1) * 3600 * 4 + AYB.TextToSecs(s[8]) + 57, -- 57 is a fudge factor since the string for time left immediately starts at 3 hr 59 minutes
			["doBroadcast"] = true,
			["blacklist"] = false,
			} 
		if AllYourBaseVars.Settings.notifyOnQueueUpdate then
			AYB.Print(format("Work order queue for %s has been updated!", building))
		end
	else
		AYB.Print("I think this is the first expedited shipment for ".. building)
	end
end

function AYB.Sync()
	AYB.AddAnyMissing()
	if not AYB.Constants.hasLoggedIn and AllYourBaseVars.Settings.displayReportAtLogin then
		AYB.DisplayAllReports("initial")
		AYB.Constants.hasLoggedIn = true
		return
	end
	if AllYourBaseVars.Settings.scanForMissions then
		AYB.SearchAllForCompleteMissions(false, "from Sync")
	end
	if AllYourBaseVars.Settings.scanForBuildings then
		AYB.SearchAllForCompleteBuildings(false, "from Sync")
	end
	if AllYourBaseVars.Settings.scanForShipments then
		AYB.SearchAllForCompleteShipments(false, "from Sync")
	end
	if AllYourBaseVars.Settings.scanForResources then
		AYB.SearchAllForResourceLimit(false, "from Sync")
	end
	AYB.Constants.hasLoggedIn = true
end

function AYB.AddAnyMissing()
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.isBuilding == false and AllYourBaseVars.Data[me].Missions then -- if this is not a Building, it's a Mission
			if not AllYourBaseVars.Data[me].Missions[v.missionID] then
				AllYourBaseVars.Data[me].Missions[v.missionID] = v
				AllYourBaseVars.Data[me].Missions[v.missionID]["startTime"] = "unknown"
				local timeLeft = C_Garrison.GetLandingPageItems()[k].timeLeft
				AllYourBaseVars.Data[me].Missions[v.missionID].endTime = time() + AYB.TextToSecs(timeLeft)
				AllYourBaseVars.Data[me].Missions[v.missionID].doBroadcast = true
			end
		elseif AllYourBaseVars.Data[me].Buildings then -- it's a Building
			if not AllYourBaseVars.Data[me].Buildings[v.name] then
				AllYourBaseVars.Data[me].Buildings[v.name] = v
				AllYourBaseVars.Data[me].Buildings[v.name]["startTime"] = "unknown"
				local timeLeft = C_Garrison.GetLandingPageItems()[k].timeLeft
				AllYourBaseVars.Data[me].Buildings[v.name].endTime = time() + AYB.TextToSecs(timeLeft)
				AllYourBaseVars.Data[me].Buildings[v.name].doBroadcast = true
			end
		end
	end
	
	local buildings, shipments = C_Garrison.GetBuildings(), {}
	for i = 1, #buildings do
		local buildingID = buildings[i].buildingID
		if buildingID then
			-- local name, texture, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, timeleftString, itemName, itemIcon, itemQuality, itemID = C_Garrison.GetLandingPageShipmentInfo(buildingID);
			shipments[buildingID] = {C_Garrison.GetLandingPageShipmentInfo(buildingID)}
		end
	end
	for k, v in pairs(shipments) do
		if v[1] and AllYourBaseVars.Data[me].Shipments and not AllYourBaseVars.Data[me].Shipments[v[1]] then
			if v[8] then
				v[8] = AYB.TextToSecs(v[8]) + time() + (v[5] - v[4] - 1) * 3600 * 4 + 57
			else
				v[8] = time() - 1
			end
			AllYourBaseVars.Data[me].Shipments[v[1]] = {
				["blacklist"] = false,
				["doBroadcast"] = true,
				["endTime"] = v[8]
			}
		end
	end	
end

function AYB.RemoveCompletedMission(missionID)
	if AllYourBaseVars.Settings.debugMode then
		AYB.Print(format("Removing %s (mission %d)", AllYourBaseVars.Data[me].Missions[missionID].name, missionID))
	end
	AllYourBaseVars.Data[me].Missions[missionID] = nil
end

function AYB.RemoveCompletedBuilding(...)
	local _, buildingID = ...
	local name = AYB.BuildingIDsToNames[buildingID][UnitFactionGroup("player")]
	AllYourBaseVars.Data[me].Buildings[name] = nil
end

function AYB.NextToComplete(dataType)
	local leastTimeRemaining, whichToon, nextName = 7 * 24 * 3600
	for k, v in pairs(AllYourBaseVars.Data) do
		for l, w in pairs(v[dataType]) do
			local thisTimeLeft = w.endTime - time()
			if (thisTimeLeft <= leastTimeRemaining) and not (time() > w.endTime) then
				leastTimeRemaining = thisTimeLeft
				whichToon = k
				nextName = w.name or l
			end
		end
	end
	
	return whichToon, nextName, leastTimeRemaining
	
	--[[
	if whichToon then
		if whichToon == me then
			AYB.Print(format("I have the next %s, Commander! %s will be ready in %s.", string.lower(string.sub(dataType, 1, -2)), nextName, AYB.SecsToText(leastTimeRemaining)))
		else
			AYB.FakeWhisper(whichToon, format("%s: %s |cFFFFFF19%s|r will be ready in %s.", dataType, AYB.UpNext[AllYourBaseVars.Data[whichToon].Race], nextName, AYB.SecsToText(leastTimeRemaining)))
		end
	else
		AYB.Print(format("You have no queued %s - better start one soon!", string.lower(dataType)))
	end
	--]]
end

function AYB.Print(msg)
	print(format("|cFFFFFF19All Your Base:|r %s", msg))
end

function AYB.CleanUpUnusedEntries(dataType)
	if AllYourBaseVars.Data[me][dataType] then
		for k, v in pairs(AllYourBaseVars.Data[me][dataType]) do
			local ID = ( dataType == "Missions" and v.missionID ) or ( dataType == "Buildings" and v.name )
			local isActive = nil
			for l, w in ipairs(C_Garrison.GetLandingPageItems()) do
				if ( dataType == "Missions" and ID == w.missionID ) or ( dataType == "Buildings" and ID == w.name ) then
					isActive = true
					break
				end
			end
			if not isActive then
				AllYourBaseVars.Data[me][dataType][ID] = nil
			end
		end
	end
end

function AYB.SearchAllForCompleteMissions(onDemand, source) -- returns quantity of completed missions, and a string with a report (if multiple) - otherwise triggers a single notification to fire (not a report)
	-- print("search missions", onDemand, source)
	local meComplete, otherComplete
	for k, v in pairs(AllYourBaseVars.Data) do
		for l, w in pairs(v.Missions) do
			if time() >= w.endTime and (w.doBroadcast or source == "initial" or source == "slash") then
				w.doBroadcast = false
				tinsert(AYB.CompletedQueue, k.."/"..w.missionID)
				if k == me then
					meComplete = true
				else
					otherComplete = true
				end
			end
		end
	end
	-- print("search missions mecomplete? othercomplete?", meComplete, otherComplete)
	-- print(format("me: %s, other: %s", meComplete and "yes" or "no", otherComplete and "yes" or "no"))
	if meComplete or otherComplete then
		if onDemand and otherComplete then
			-- print("starting mission report with # =", #AYB.CompletedQueue)
			return AYB.CreateCompletedMissionReport(source)
		elseif otherComplete then
			if AllYourBaseVars.Settings.debugMode then
				print(unpack(AYB.CompletedQueue))
				print(format("meComplete: %s, otherComplete: %s, source: %s", tostring(meComplete) or "nil", tostring(otherComplete) or "nil", tostring(source) or "source not given"))
			end
			local toon, missionID = string.match(AYB.CompletedQueue[1], "([^/]+)/(%d+)")
			AYB.DisplayCompletedSingleMission(toon, tonumber(missionID))
			AYB.FakeWhisper(toon, "Mission completed!")
			AYB.CompletedQueue = {}
		elseif onDemand and meComplete then
			-- AYB.Print(format("I have %d %s complete, Commander!", #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "missions" or "mission"))
			local qty, msg = #AYB.CompletedQueue, format("%s has %d %s complete.", shortMe, #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "missions" or "mission")
			AYB.CompletedQueue = {}
			return qty, msg
		end
	elseif onDemand then
		-- AYB.Print("No one has any completed missions, Commander!")
		return 0, ""
	end
end

function AYB.DisplayCompletedSingleMission(char, missionID)
	local missionsInfo
	GarrisonLandingPageMinimapButton.MinimapLoopPulseAnim:Play();
	if AllYourBaseVars.Data[char].Missions[missionID] then
		missionInfo = AllYourBaseVars.Data[char].Missions[missionID]
	else -- why is this doing this?
		AYB.Print(format("Not sure why, but I just tried to get information about mission %s, which I don't have for %s!", missionID, char))
		return
	end
	GarrisonMissionAlertFrame.Name:SetText(missionInfo.name);
	GarrisonMissionAlertFrame.MissionType:SetAtlas(missionInfo.typeAtlas);
	AlertFrame_AnimateIn(GarrisonMissionAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_MissionComplete");
end

function AYB.CreateCompletedMissionReport(source)
	-- print("creating mission report from", source)
	local done, chars, toonCount, currentComplete, qty, msg, toon = {}, {}, 1, 0, 0
	--[[for k, v in pairs(AllYourBaseVars.Data[me].Missions) do
		if time() >= v.endTime then
			currentComplete = currentComplete + 1
		end
	end]]
	-- local PHCOUNTER = 0
	for k, v in ipairs(AYB.CompletedQueue) do
		toon = string.match(v, "([^/]+)")
		-- local toon = string.match(key, "([^-]+)")
		-- print(key, toon)
		if not done[toon] then
			done[toon] = 0
			tinsert(chars, toon)
		end
		done[toon] = done[toon] + 1
		-- PHCOUNTER = PHCOUNTER + 1
	end
	-- print("PHCOUNTER", PHCOUNTER)
	local total = "for a total of "..#AYB.CompletedQueue..(#AYB.CompletedQueue == 1 and " mission." or " missions. ")
	msg = ""
	for k, v in pairs(done) do
		local subject = k:match("([^-]+)")
		local verb = "has completed"
		local singplural = (v == 1 and "mission" or "missions")
		local punc
		if toonCount == (#chars - 1) then
			punc = ", and "
		elseif toonCount == #chars then
			punc = ","
		else
			punc = ". "
		end
		msg = msg..format("%s %s %d %s%s", subject, verb, v, singplural, punc)
		toonCount = toonCount + 1
	end		
	msg = format("%s %s", msg, total)
	qty = #AYB.CompletedQueue
	-- print("# of missions is!", #AYB.CompletedQueue)
	AYB.CompletedQueue = {}
	-- print("New # of queue is!", #AYB.CompletedQueue)
	return qty, msg
end

function AYB.SearchAllForCompleteBuildings(onDemand, source) -- returns quantity of completed buildings, and a string with a report (if multiple) - otherwise triggers a single notification to fire (not a report)
	local meComplete, otherComplete
	-- print("start search for buildings!", #AYB.CompletedQueue)
	for k, v in pairs(AllYourBaseVars.Data) do
		for l, w in pairs(v.Buildings) do
			if time() >= w.endTime and (w.doBroadcast or source == "initial" or source == "slash") then
				w.doBroadcast = false
				tinsert(AYB.CompletedQueue, k.."/"..w.name)
				if k == me then
					meComplete = true
				else
					otherComplete = true
				end
			end
		end
	end
	if meComplete or otherComplete then
		if onDemand and otherComplete then
			return AYB.CreateCompletedBuildingReport(source)
		elseif otherComplete then
			local toon, name = string.match(AYB.CompletedQueue[1], "([^/]+)/(.+)")
			AYB.FakeWhisper(toon, format("My %s is completed!", name))
			AYB.DisplayCompletedSingleBuilding(toon, name)
			AYB.CompletedQueue = {}
		elseif onDemand and meComplete then
			-- AYB.Print(format("I have %d %s complete, Commander!", #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "buildings" or "building"))
			local qty, msg = #AYB.CompletedQueue, format("%s has %d %s complete.", shortMe, #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "buildings" or "building")
			AYB.CompletedQueue = {}
			return qty, msg
		end
	elseif onDemand then
		-- AYB.Print("No one has any completed buildings, Commander!")
		return 0, ""
	end
end

function AYB.DisplayCompletedSingleBuilding(toon)
	local name = toon:match("([^-]+)-.+")
	GarrisonBuildingAlertFrame.Name:SetFormattedText("%s has a finished building!", name);
	AlertFrame_AnimateIn(GarrisonBuildingAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_BuildingComplete");
end

function AYB.CreateCompletedBuildingReport(source)
	-- AYB.Print(source)
	local done, chars, toonCount, currentComplete, qty, msg, toon, key, building = {}, {}, 1, 0, 0, ""
	--[[for k, v in pairs(AllYourBaseVars.Data[me].Missions) do
		if time() >= v.endTime then
			currentComplete = currentComplete + 1
		end
	end]]
	for k, v in ipairs(AYB.CompletedQueue) do
		key, building = string.match(v, "([^/]+)/(.+)")
		toon = string.match(key, "([^-]+)")
		-- print(key, building)
		if not done[toon] then
			done[toon] = {}
			if toon ~= string.match(me, "([^-]+)") then
				tinsert(chars, key)
			end
		end
		tinsert(done[toon], building)
	end
--	print("[chars] has entries " .. #chars)
	local total = ", for a total of "..#AYB.CompletedQueue.." buildings."
	msg = ""
	for k, v in pairs(done) do
		msg = msg .. format("%s %s completed %d %s:", k, "has", #v, (#v == 1 and "building" or "buildings"))
		for l, w in ipairs(v) do
			if #v == 1 then
				msg = msg .. " " .. w .. ". "
			elseif l == #v then
				msg = msg .. " and " .. w .. ". "
			else
				msg = msg .. " " .. w .. ","
			end
		end
	end
	qty = #AYB.CompletedQueue
	AYB.CompletedQueue = {}
	return qty, msg
end

function AYB.SearchAllForCompleteShipments(onDemand, source) -- returns quantity of completed shipments, and a string with a report (if multiple) - otherwise triggers a single notification to fire (not a report)
	-- if onDemand then print("Searching for Shipments ON DEMAND") end
	local meComplete, otherComplete
	-- print("start search for shipments: ", #AYB.CompletedQueue)
	for k, v in pairs(AllYourBaseVars.Data) do
		for l, w in pairs(v.Shipments) do
			if not w.blacklist then
				if time() >= w.endTime and (w.doBroadcast or source == "initial" or source == "slash") then
					-- print(k.."/"..l)
					w.doBroadcast = false
					tinsert(AYB.CompletedQueue, k.."/"..l)
					if k == me then
						meComplete = true
					else
						otherComplete = true
					end
				end
			end
		end
	end
	if meComplete or otherComplete then
		if onDemand and otherComplete then
			return AYB.CreateCompletedShipmentReport(source)
		elseif otherComplete then
			local toon, building = string.match(AYB.CompletedQueue[1], "([^/]+)/(.+)")
			AYB.DisplayCompletedSingleShipment(toon)
			AYB.FakeWhisper(toon, format("My %s has finished all work orders!", building))
			AYB.CompletedQueue = {}
		elseif meComplete and not onDemand then
			AYB.Print(format("I have %d work order %s that %s attention, Commander!", #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "queues" or "queue", #AYB.CompletedQueue > 1 and "need" or "needs"))
			local toon, building = string.match(AYB.CompletedQueue[1], "([^/]+)/(.+)")
			AYB.DisplayCompletedSingleShipment(toon)
			AYB.CompletedQueue = {}
		elseif meComplete then
			-- AYB.Print(format("I have %d work order %s that %s attention, Commander!", #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "queues" or "queue", #AYB.CompletedQueue > 1 and "need" or "needs"))
			local qty, msg = #AYB.CompletedQueue, format("%s has %d work order %s that %s attention.", shortMe, #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "queues" or "queue", #AYB.CompletedQueue > 1 and "need" or "needs")
			AYB.CompletedQueue = {}
			return qty, msg
		end
	elseif onDemand then
		-- AYB.Print("Everyone's queues are running smoothly, Commander!")
		return 0, ""
	end
end

function AYB.DisplayCompletedSingleShipment(toon)
	local name = toon:match("([^-]+)-.+")
	GarrisonLandingPageMinimapButton.MinimapLoopPulseAnim:Play();
	GarrisonBuildingAlertFrame.Name:SetFormattedText("Work order up! (%s)", name);
	AlertFrame_AnimateIn(GarrisonBuildingAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_BuildingComplete");
end

function AYB.CreateCompletedShipmentReport(source)
	local done, chars, toonCount, currentComplete, qty, msg, toon, key, shipment = {}, {}, 1, 0, 0, ""
	-- print("start building shipments!", #AYB.CompletedQueue)
	for k, v in ipairs(AYB.CompletedQueue) do
		key, shipment = string.match(v, "([^/]+)/(.+)")
		toon = string.match(key, "([^-]+)")
		if not done[toon] then
			done[toon] = {}
			if toon ~= string.match(me, "([^-]+)") then
				tinsert(chars, key)
			end
		end
		tinsert(done[toon], shipment)
	end
	local total = ", for a total of "..#AYB.CompletedQueue.." work order queues."
	msg = ""
	for k, v in pairs(done) do
		msg = msg .. format("%s has %d %s that %sn't producing goods: ", k, #v, (#v == 1 and "building" or "buildings"), (#v == 1 and "is" or "are"))
		for l, w in ipairs(v) do
			if #v == 1 then
				msg = msg .. w .. ". "
			elseif l == #v then
				msg = msg .. "and " .. w .. ". "
			else
				msg = msg .. w .. ", "
			end
		end
	end
	qty = #AYB.CompletedQueue
	AYB.CompletedQueue = {}
	-- print("pass through shipment", qty, msg)
	return qty, msg
end

function AYB.SearchAllForResourceLimit(onDemand, source)
	local toon
	for k, v in pairs(AllYourBaseVars.Data) do
		-- loop through people, check for anyone who's over, and then broadcast them if they need to
		if v.cacheTimer then
			if time() >= v.cacheTimer and not v.broadcastCache then
				v.broadcastCache = true
				toon = k:match("([^-]+)-.+")
				GarrisonBuildingAlertFrame.Name:SetFormattedText("%s: %d Resources!", toon, AllYourBaseVars.Settings.resourceWatchLimit)
				AlertFrame_AnimateIn(GarrisonBuildingAlertFrame);
				AlertFrame_FixAnchors();
				PlaySound("UI_Garrison_Toast_BuildingComplete");
			end
		end
	end
end

function AYB.DisplayAllReports(source)
	AYB.CompletedQueue = {}
	local doReport, msg, block1, block2, block3
	if AllYourBaseVars.Settings.includeMissionsInStatus then		
		local thisQty, thisMsg = AYB.SearchAllForCompleteMissions(true, source)
		if thisQty > 0 then -- if there are any characters who are reporting out on completed missions
			block1 = "|cFFFFFF19Missions:|r " .. thisMsg
			doReport = true
		end
	end
	if AllYourBaseVars.Settings.includeBuildingsInStatus then		
		local thisQty, thisMsg = AYB.SearchAllForCompleteBuildings(true, source)
		if thisQty > 0 then -- if there are any characters who are reporting out on completed buildings
			if block1 then
				block2 = "|cFFFFFF19Buildings:|r " .. thisMsg
			else
				block1 = "|cFFFFFF19Buildings:|r " .. thisMsg
			end
			doReport = true
		end
	end
	if AllYourBaseVars.Settings.includeShipmentsInStatus then		
		local thisQty, thisMsg = AYB.SearchAllForCompleteShipments(true, source)
		if thisQty > 0 then -- if there are any characters who are reporting out on completed shipments
			if block2 and block1 then
				block3 = "|cFFFFFF19Work Orders:|r " .. thisMsg
			elseif block1 then
				block2 = "|cFFFFFF19Work Orders:|r " .. thisMsg
			else
				block1 = "|cFFFFFF19Work Orders:|r " .. thisMsg
			end
			doReport = true
		end
	end
	if doReport then
		local toons, randomToon, speakerRace, intro = {}
		for k, v in pairs(AllYourBaseVars.Data) do
			if k ~= me then
				tinsert(toons, k)
			end
		end
		AllYourBaseReportPageReportText:SetWidth(500)
		AllYourBaseReportPageReportText:Show()
		if #toons == 0 then
			AllYourBaseReportPageReportText:SetText("I'm the only one with a Garrison so far, Commander! Check your Garrison report, and make sure to log into your other characters!")
		else
			if block3 then
				msg = format(block1 .. "\n\n" .. block2 .. "\n\n" .. block3)
			elseif block2 then
				msg = format(block1 .. "\n\n" .. block2)
			else
				msg = block1
			end
			randomToon = toons[random(#toons)]
			AllYourBase.FadeFrame(AllYourBaseReportPage, 1)
			speakerRace = AllYourBaseVars.Data[randomToon].Race
			intro = AllYourBase.StatusIntros[speakerRace][random(#AllYourBase.StatusIntros[speakerRace])]
			AllYourBaseReportPageReportHeaderText:SetText("All Your Base: Status Report from "..randomToon:match("([^-]+)"))
			AllYourBaseReportPageReportText:SetText(shortMe.." reaches into a nearby mailbox and retrieves a neatly penned scroll. It reads:\n\n'"..intro.."\n\n"..msg:gsub(randomToon:match("([^-]+)") .. " has", "I have"):gsub(shortMe, "Your current garrison"):gsub("and Your", "and your").."'")
		end
	else
		AllYourBaseReportPageReportText:Show()
		AllYourBaseReportPageReportText:SetText("There are no completed missions, buildings, or shipments for anyone, Commander!")
	end
	for i, v in ipairs({"Missions", "Buildings", "Shipments"}) do
		local toon, objective, remaining = AYB.NextToComplete(v)
		if objective then
			_G["AllYourBaseReportPageNextTime"..i]:SetText(AYB.SecsToText(remaining))
			_G["AllYourBaseReportPageNextName"..i]:SetText("("..toon:match("([^-]+)")..")")
		else
			_G["AllYourBaseReportPageNextTime"..i]:SetText("None in progress!")
			_G["AllYourBaseReportPageNextName"..i]:SetText("")
		end
	end
	_G["AllYourBaseReportPageResourcesText"]:SetText(format("|cFFFFFF19Garrison Cache:|r %s", AYB.NextToonResourceCap()))
	AYB.FadeFrame(AllYourBaseReportPage, 1)
	AYB.CompletedQueue = {}
end

function AYB.NextToonResourceCap()
	local limit, highest, toon, timeLeft = AllYourBaseVars.Settings.resourceWatchLimit, 9999999999999999999999
	for k, v in pairs(AllYourBaseVars.Data) do
		if v.cacheTimer then	
			if v.cacheTimer <= highest then
				highest = v.cacheTimer
				toon = k
				timeLeft = v.cacheTimer - time()
			end
		end
	end
	local textString
	if tonumber(timeLeft) < 0 then
		textString = format("%s has already reached your resource limit of %d!", toon, limit)
	else
		textString = format("%s will reach your resource limit of %d in about %s.", toon, limit, AYB.SecsToText(timeLeft))
	end
	return textString
end

function AYB.Blacklist(building)
	if not building then
		AYB.Print("To blacklist a building's work orders, use '/ayb blacklist <EXACT NAME OF BUILDING>.' To review the contents of your blacklist, type /ayb blacklist show.")
		return
	else
		building = AYB.ProperCase(building)
	end
	if building == "show" then
		-- show all blacklisted buildings
	else
		if not AllYourBaseVars.Data[me].Shipments[building] then
			AYB.Print(format("I don't know anything about your %s. Maybe you haven't done any work orders there yet?", building))
			return
		else
			if AllYourBaseVars.Data[me].Shipments[building].blacklist then
				AYB.Print(format("Your %s has been removed from the blacklist, and you will now get notifications when its queue is up.", building))
				AllYourBaseVars.Data[me].Shipments[building].blacklist = false
			else
				AYB.Print(format("Blacklisting %s! Its work orders will no longer be called to your attention.", building))
				AllYourBaseVars.Data[me].Shipments[building].blacklist = true
			end
		end
	end
end

function AYB.FakeWhisper(character, msg)
	local toon = (character:find("-")) and character:match("([^-]+)") or character
	AYB.Print(format('%s snaps to a crisp salute. "%s"', toon, msg))
	PlaySound("TellMessage")
end

function AYB.SlashHandler(cmd)
	if cmd:find("blacklist") then
		AYB.Blacklist(cmd:match("blacklist (.+)"))
	--[[
	elseif cmd == "next" then
		AYB.NextToComplete("Missions")
		AYB.NextToComplete("Buildings")
		AYB.NextToComplete("Shipments")
	elseif cmd == "next mission" then
		AYB.NextToComplete("Missions")
	elseif cmd == "next shipment" then
		AYB.NextToComplete("Shipments")
	elseif cmd == "next building" then
		AYB.NextToComplete("Buildings")
	elseif cmd == "missions" then
		AYB.SearchAllForCompleteMissions(true, "from slash")
	elseif cmd == "buildings" then 
		AYB.SearchAllForCompleteBuildings(true, "from slash")
	elseif cmd == "shipments" then
		AYB.CreateCompletedShipmentReport()
	--]]
	elseif cmd == "status" then
		AYB.DisplayAllReports("slash")
	elseif cmd == "nuke" then
		AYB.InitializeVariablesAndSettings()	
	--elseif cmd == "anim" then
		--AYB.ReportModel:SetSequenceTime(0,0)
		--AYB.ReportModelTimer.Timer = 0
		--AYB.ReportModelTimer:Show()
	else
		AYB.Print("Unknown option. Make sure your commands are in all lowercase letters.")
	end
end

SLASH_ALLYOURBASE1 = "/ayb"
SlashCmdList["ALLYOURBASE"] = function(msg)
	AYB.SlashHandler(msg)
	end
	
function AYB.TextToSecs(timeLeft)
	-- print(timeLeft)
	if not timeLeft then
		return
	end
	local hr, mins, secs
	if string.find(timeLeft, "hr") then
		hr = string.match(timeLeft, "(%d+) hr")
	end
	if string.find(timeLeft, "min") then
		mins = string.match(timeLeft, "(%d+) min")
	end
	hr = hr or 0; mins = mins or 0
	return ((hr * 3600) + (mins * 60))
end

function AYB.SecsToText(timeLeft)
	local hr, mins, secs = math.floor(timeLeft / 3600), math.floor(timeLeft / 60) % 60, timeLeft % 60
	return format("%d hr, %d min, %d sec", hr, mins, secs)
end

function AYB.ProperCase(str)
	local w1, w2
	if str:find(" ") then
		w1, w2 = str:match("(%S+) (%S+)")
	end
	return w2 and (w1:sub(1,1):upper() .. w1:sub(2) .. " " .. w2:sub(1,1):upper() .. w2:sub(2)) or (str:sub(1,1):upper() .. str:sub(2))
end

function AYB.CaptureInventoryIDs()
	for k, v in pairs(AllYourBase.InventorySlots) do
		AllYourBaseVars.Data[me].Inventory[v] = select(6, GetTransmogrifySlotInfo(v))
	end
	if not ShowingHelm() then
		AllYourBaseVars.Data[me].Inventory[1] = nil
	end
end

function AYB.NextReport()
	AllYourBaseNextPage:Show()
	-- AYB.ModelAlphaTimer:Show()
	AllYourBaseNextPageReportHeaderText:SetText("Upcoming Actions Report")
	-- AllYourBaseNextPageReportText:Hide()
	local data = {"Missions", "Buildings", "Shipments"}
	for i = 1, 3 do
		local dataType = data[i]
		local toon, objective, remaining = AYB.NextToComplete(dataType)
		if objective then
			_G["AllYourBaseReportPageNextTime"..i]:SetText(AYB.SecsToText(remaining))
			_G["AllYourBaseReportPageNextName"..i]:SetText(toon:match("([^-]+)"))
			-- local DUM = _G["AllYourBaseNextModel"..i]
			-- print(data[i], type(DUM))
			-- DUM:Show()
			-- print("showed model "..i)
			-- DUM:SetUnit("player")
			-- print("model "..i.." is now player")
			-- DUM:SetCustomRace(AllYourBaseVars.Data[toon].RaceID, AllYourBaseVars.Data[toon].Gender)
			-- print("model "..i.." is now", AllYourBaseVars.Data[toon].RaceID, AllYourBaseVars.Data[toon].Gender)
			-- DUM:Undress()
			-- print("model "..i.." is naked!")
			-- for k, v in pairs(AllYourBaseVars.Data[toon].Inventory) do
			-- 	DUM:TryOn(v)
			-- end
			-- DUM:UndressSlot(16)
			-- DUM:UndressSlot(17)
			-- DUM:UndressSlot(18)
			-- print("model "..i.." is dressed!")
		else
			_G["AllYourBaseReportPageNextTime"..i]:SetText("None in progress!")
			_G["AllYourBaseReportPageNextName"..i]:SetText("")
			-- _G["AllYourBaseNextModel"..i]:Hide()
		end
	end
	AYB.FadeFrame(AllYourBaseNextPage, 1)
end

function AYB.ReportPage.OnLoad(self)
	local texts = {"Mission", "Building", "Work Order"}
	for i = 1, 3 do
		local t = self:CreateFontString("AllYourBaseReportPageNextText"..i, "BORDER", "GameFontNormal")
		t:SetPoint("CENTER", (i - 2) * 200, -145)
		t:SetText("Next "..texts[i].." in:")
		local fs = self:CreateFontString("AllYourBaseReportPageNextTime"..i, "BORDER")
		fs:SetFont("Fonts\\ARIALN.ttf", 12)
		fs:SetShadowOffset(1, -1)
		fs:SetShadowColor(0, 0, 0)
		fs:SetPoint("CENTER", (i - 2) * 200, -165)
		local n = self:CreateFontString("AllYourBaseReportPageNextName"..i, "BORDER")
		n:SetFont("Fonts\\FRIZQT__.ttf", 14)
		n:SetTextColor(0.41, 0.5, 0.94)
		n:SetPoint("CENTER", (i - 2) * 200, -185)
	end
end

function AllYourBase.FadeFrame(frame, a)
	-- print(frame:GetName())
	if not frame:IsShown() then
		frame:Show()
	end
	frame.Timer = (a == 1 and 0 ) or 0.25
	frame.keepFading = true
	frame:SetScript("OnUpdate", function(self, elapsed) self.Timer = self.Timer + (a * elapsed)
		if self.keepFading then
			self:SetAlpha(self.Timer * 4)
		end
		if (a == 1 and self.Timer >= 0.25) then 
			if self:GetName() == "AllYourBaseReportPage" and self.keepFading then
				-- AYB.ReportModelTimer:Show()
			end
			self.keepFading = false
		elseif (a == -1 and self.Timer <= 0) then
			self.keepFading = false
			self:Hide()
		end
	end)
end

function AYB.SetOptionsChecks()
	for k, v in ipairs(AllYourBase.SettingsMap) do 
		if _G["AllYourBaseCheckButton"..k] then
			_G["AllYourBaseCheckButton"..k]:SetChecked(AllYourBaseVars.Settings[v.key])
		end
	end
	_G["AllYourBaseResourceSlider"]:SetValue(AllYourBaseVars.Settings.resourceWatchLimit)
	_G["AllYourBaseResourceSliderText"]:SetFormattedText("Resource Watch: %d (used in the Status Report and alerts, if checked above)", AllYourBaseVars.Settings.resourceWatchLimit)
end

function AllYourBase.CollectSettings()
	for k, v in ipairs(AllYourBase.SettingsMap) do
		local val = _G["AllYourBaseCheckButton"..k]:GetChecked()
		AllYourBaseVars.Settings[v.key] = val
	end
	AllYourBaseVars.Settings.resourceWatchLimit = _G["AllYourBaseResourceSlider"]:GetValue()
	-- redo all cache timers with the new timer
	for k, v in pairs(AllYourBaseVars.Data) do
		if v.cacheTimer and v.lastRetrievedCache then
			v.cacheTimer = v.lastRetrievedCache + (AllYourBaseVars.Settings.resourceWatchLimit / 6 * 3600)
		end
	end
end

function AYB.CancelOptions()
	_G["AllYourBaseResourceSlider"]:SetValue(AllYourBaseVars.Settings.resourceWatchLimit)
end

function AYB.InitializeVariablesAndSettings()
	AllYourBaseVars = {
		["CurrentVersion"] = AYB.Constants.CurrentVersion,
		["Settings"] = {
			["scanForShipments"] = true,
			["scanForBuildings"] = true,
			["includeMissionsInStatus"] = true,
			["scanForMissions"] = true,
			["includeBuildingsInStatus"] = true,
			["includeShipmentsInStatus"] = true,
			["displayReportAtLogin"] = false,
			["doNotNotifyDuringBattle"] = false,
			["notifyOnQueueUpdate"] = true,
			["resourceWatchLimit"] = 450,
			["scanForResources"] = true,
			["debugMode"] = false,
		},
		["Data"] = {},
	}
end

function AYB.Options.OnLoad(self)
	for k, v in ipairs(AllYourBase.SettingsMap) do 
		local b = CreateFrame("CheckButton", "AllYourBaseCheckButton"..k, AllYourBaseOptions, "AllYourBaseCheckButton")
		b:SetHeight(26)
		b:SetWidth(26)
		_G[b:GetName().."Text"]:SetText(v.desc)
		_G[b:GetName().."Text"]:SetTextHeight(12)
		b.ID = k
		b:Show()
		b:SetPoint("TOPLEFT", 15, -((k-1) * 30) - 15)
		if (v.desc):find("battle") then -- disable the battle hook button, NYI
			b:Disable()
			_G[b:GetName().."Text"]:SetText(v.desc.." (NYI)")
			_G[b:GetName().."Text"]:SetTextColor(0.5, 0.5, 0.5)
		end
		if (v.desc):find("debug") then -- disable debug button, not for end users
			b:Disable()
			_G[b:GetName().."Text"]:SetText(v.desc.." (for dev use only in Beta)")
			_G[b:GetName().."Text"]:SetTextColor(0.5, 0.5, 0.5)
		end
	end

	local sl = CreateFrame("Slider", "AllYourBaseResourceSlider", AllYourBaseOptions, "OptionsSliderTemplate")
	sl:SetHeight(15)
	sl:SetWidth(200)
	sl.ID = k
	sl:SetPoint("BOTTOM", 0, 40)
	sl:SetMinMaxValues(100, 500)
	sl:SetValue(10)
	sl:SetValueStep(10)
	_G[sl:GetName().."Low"]:SetText("100")
	_G[sl:GetName().."High"]:SetText("500")		
	sl:SetScript("OnValueChanged", function(self, value)
		   -- start fix
	   if not self._onsetting then   -- is single threaded 
		 self._onsetting = true
		 self:SetValue(self:GetValue())
		 value = self:GetValue()     -- cant use original 'value' parameter
		 self._onsetting = false
	   else return end               -- ignore recursion for actual event handler
	   -- end fix
	   _G[self:GetName().."Text"]:SetFormattedText("Resource Watch: %d (used in the Status Report and alerts, if checked above)", value)

	end)
	sl:Show()			
	
	self.name = "All Your Base"
	self.okay = AYB.CollectSettings
	self.cancel = AYB.CancelOptions
	InterfaceOptions_AddCategory(self)
end

AYB.Main:SetScript("OnEvent", AYB.Main.OnEvent)
AYB.Main:SetScript("OnUpdate", AYB.Main.OnUpdate)
AYB.ShipmentUpdater:SetScript("OnUpdate", AYB.ShipmentUpdater.OnUpdate)
AYB.WhichCrafter:SetScript("OnEvent", AYB.ParseCrafter)
-- AYB.ReportModelTimer:SetScript("OnUpdate", AYB.ReportModelTimer.OnUpdate)
-- AYB.ModelAlphaTimer:SetScript("OnUpdate", AYB.ModelAlphaTimer.OnUpdate)

